program DBX2MBX;
{&D-}
{$I+}
{$ifndef VPASCAL}
  {$define Delphi}
{$endif}

{$ifdef Delphi}
  {$APPTYPE CONSOLE}
  {.$O-}
{$endif}

uses
    DbxOut, {Recode,} Windows, SysUtils;

function FileTimeToDateTime(ADate: TFileTime): TDateTime;
var
   LocalFileTime: TFileTime;
   FileDate: Integer;
begin
     FileTimeToLocalFileTime(ADate, LocalFileTime);
     FileTimeToDosDateTime(LocalFileTime, LongRec(FileDate).Hi,
                                          LongRec(FileDate).Lo);
     Result:=FileDateToDateTime(FileDate);
end;

{$ifdef Delphi}
function DateTimeToStrEn(ADate: TDateTime): String;
const
     Days: array[1..7] of string[3] = ('Sun', 'Mon', 'Tue', 'Wed',
                                       'Thu', 'Fri', 'Sat');
     Months: array[1..12] of string[3] = ('Jan', 'Feb', 'Mar',
                                          'Apr', 'May', 'Jun',
                                          'Jul', 'Aug', 'Sep',
                                          'Oct', 'Nov', 'Dec');
var
   Year, Month, Day: Word;
begin
     DecodeDate(ADate, Year, Month, Day);
     Result:=Days[DayOfWeek(ADate)]+' '+Months[Month]+' '+
             FormatDateTime('dd hh:nn:ss yyyy', ADate);
end;
{$else}
function DateTimeToStrEn(ADate: TDateTime): String;
begin
     Result:=FormatDateTime('ddd mmm dd hh:nn:ss yyyy', ADate);
end;
{$endif}

procedure DBXMsgList(DBXName: AnsiString);
var
   Count, Current, Size: DWORD;
   hDBX: THDBX;
   pDBXLockData: TPDBXLockData;
   DateSt, Subject, FromName, St: AnsiString;
   pTmp: PChar;
begin
{$ifndef Delphi}
  OEMToChar(pChar(DBXName), pChar(DBXName));
{$endif}
  hDBX:=DBXOpen(pChar(DBXName));
  if hDBX<>DBXError then
  begin
    Count:=DBXGetMsgCount(hDBX);
    if Count>0 then
      for Current:=0 to Count-1 do
      begin
        DBXGetMsgByPos(hDBX, Current, nil, Size);
        pDBXLockData:=DBXLockMsgHeaderByPos(hDBX, Current);
        DateSt:=FormatDateTime('dd.mm.yyyy hh:nn', FileTimeToDateTime(
                           DBXGetTimeRecieved(TPDBXHeaderData(pDBXLockData))^));

        Subject:=StrPas(DBXGetOSubject(TPDBXHeaderData(pDBXLockData)));
        if Subject='' then Subject:='(NoSubject)';

        FromName:=StrPas(DBXGetFromName(TPDBXHeaderData(pDBXLockData)));
        if FromName='' then
        begin
          FromName:=StrPas(DBXGetFromAddres(TPDBXHeaderData(pDBXLockData)));
          if FromName='' then FromName:='(NoName)';
        end;

        DBXUnlock(pDBXLockData);
//        St:=EncodeString(Subject+'\'+FromName+'\');
        St:=Subject+'\'+FromName+'\';
        CharToOEM(pChar(St), pChar(St));
        Writeln(DateSt, ' ', Size:10, ' ', St, Current, '.msg');
      end;
    DBXClose(hDBX);
  end
  else
    begin
      Writeln('  䠩');
      ExitCode:=-1;
    end;
end;

procedure DBXMsgExtract(DBXName, MsgPosSt: AnsiString);
var
   hDBX: THDBX;
   MsgPos: DWORD;
begin
{$ifndef Delphi}
  OEMToChar(pChar(DBXName), pChar(DBXName));
{$endif}
  hDBX:=DBXOpen(pChar(DBXName));
  if hDBX<>DBXError then
  begin
    MsgPos:=StrToIntDef(Copy(MsgPosSt, 1, Pos('.', MsgPosSt)-1), 0);
    DBXSaveAsMsgByPos(hDBX, MsgPos, PChar(MsgPosSt));
    DBXClose(hDBX);
  end;
end;

procedure DBXToMBX(InName, OutName: AnsiString);
const
     ctFrom: PChar = 'From ';
var
   F: file;
   I,  J: DWORD;
   Count,  Current: DWORD;
   Size: DWORD;
   St: AnsiString;
   hDBX: THDBX;
   pDBXLockData: TPDBXLockData;
   pBuf: PChar;
begin
{$ifndef Delphi}
  OEMToChar(pChar(InName), pChar(InName));
{$endif}
  hDBX:=DBXOpen(pChar(InName));
  CharToOEM(pChar(InName), pChar(InName));
  if hDBX<>DBXERROR then
    begin
      if DBXIsMessageDatabase(hDBX) then
        begin
          Writeln('ࠡ⪠ 䠩: ', InName);
          AssignFile(f, OutName);
          Count:=DBXGetMsgCount(hDBX);
          if Count>0 then
            try
              Rewrite(f, 1);
              try
                for Current:=0 to Count-1 do
                begin
                  Write('饭 ', Current+1, '  ', Count, #$D);
                  pDBXLockData:=DBXLockMsgHeaderByPos(hDBX, Current);
                  pBuf:=DBXGetFromAddres(TPDBXHeaderData(pDBXLockData));
//                  if DWORD(pBuf)<>DBXERROR then
                  if pBuf<>nil then
                    St:=ctFrom+StrPas(pBuf)
                  else
                    St:=StrPas(ctFrom)+'???@???';

                  St:=St+'  '+DateTimeToStrEn(
                               FileTimeToDateTime(
                                DBXGetTimeRecieved(
                                    TPDBXHeaderData(pDBXLockData)
                                                  )^
                                                 )
                                             )+#$A;

                  DBXUnlock(pDBXLockData);
                  DBXGetMsgByPos(hDBX, Current, nil, Size);
                  if Size>0 then
                    begin
                      BlockWrite(f, St[1], Length(St));
                      pBuf:=DBXAlloc(Size+6);
                      FillChar(pBuf^, Size+6, 0);
                      DBXGetMsgByPos(hDBX, Current, @pBuf[5], Size);
                      J:=0;
                      I:=5;
                      while I<Size+5 do
                        case pBuf[I] of
                          #$D: begin
                                 pBuf[J]:=#$A;
                                 Inc(J);
                                 Inc(I);
                                 if pBuf[I]=#$A then Inc(I);
                                 if StrLComp(@pBuf[I], ctFrom, 5)=0 then
                                 begin
                                   pBuf[J]:='>';
                                   Inc(J);
                                 end
                               end;
                          #$A: begin
                                 pBuf[J]:=#$A;
                                 Inc(J);
                                 Inc(I);
                                 if pBuf[I]=#$D then Inc(I);
                                 if StrLComp(@pBuf[I], ctFrom, 5)=0 then
                                 begin
                                   pBuf[J]:='>';
                                   Inc(J);
                                 end
                               end;
                        else
                          begin
                               pBuf[J]:=pBuf[I];
                               Inc(J);
                               Inc(I);
                          end
                        end;

                      pBuf[J]:=#$A;
                      pBuf[J+1]:=#$A;
                      while pBuf[J]=#$A do Dec(J);
                      BlockWrite(f, pBuf^, J+3);

                      DBXFree(pBuf);
                    end
                end;
                Writeln('ࠡ⠭ ', Count, ' ᮮ饭(,)                        ');
              except
                on EInOutError do Writeln('訡   䠩 ', OutName);
              end;
              CloseFile(F);
            except
              on E: EInOutError do Writeln(' ᮧ 䠩 ', OutName,
                                           ' (', E.Message, ')');
            end
          else
            Writeln('   ᮮ饭');
        end
      else
        Writeln(' ', InName, '    ᥬ MS Outlook Express');
      DBXClose(hDBX);
    end
  else
    Writeln('  䠩 ', InName);
end;

Begin
  Writeln('DBX2MBX v1.0b -   ᮮ饭 OE  Unix MailBox');
  Writeln('(c) 2002 ᥩ 娭 <suhinin_alex@rambler.ru>');
  if ParamCount>=2 then
    if ParamStr(1)[1]='-' then
      case ParamStr(1)[2] of
        'l',  'L': DBXMsgList(ParamStr(2));
        'x',  'X': DBXMsgExtract(ParamStr(2), ParamStr(3));
      end
    else
      DBXToMBX(ParamStr(1),
               ParamStr(2)+'\'+ChangeFileExt(ExtractFileName(ParamStr(1)), '.mbx'))
  else
    begin
      Writeln('ᯮ짮:');
      Writeln(' - ᬮ ᯨ᮪ ᮮ饭:');
      Writeln('    DBX2MBX -l <MsgBaseName>');
      Writeln(' -  ᮮ饭:');
      Writeln('    DBX2MBX -x <MsgBaseName> <MsgName.msg>');
      Writeln(' - ஢  Unix MailBox:');
      Writeln('    DBX2MBX <MsgBaseName> <⠫ 祭>');
    end;
End.
